Package: silly
Title: Exhaustive example of inlinedocs extended tags
Type: Package
Version: 1.0
Date: 2009-11-12
Author: Keith Ponting
Maintainer: Keith Ponting <k.ponting@aurix.com>
Description: Attempt to exercise many variants of the extended ##<< tags for inline docs.
URL: http://inlinedocs.r-forge.r-project.org
License: GPL-3
LazyLoad: yes
Depends: methods

Package: inlinedocs
Title: Convert Inline Comments to Documentation
Type: Package
Version: 2023.9.4
Authors@R: c(person("Toby Dylan","Hocking",role=c("aut","cre"),
             email="toby.hocking@r-project.org"),
	  person("Keith","Ponting",role="aut"),
	  person("Thomas","Wutzler",role="aut"),
	  person("Philippe","Grosjean",role="aut"),
	  person("Markus","Müller",role="aut"),
	  person("R Core Team",role=c("ctb","cph")))
Description: Generates Rd files from R source code with comments.
 The main features of the default syntax are that
 (1) docs are defined in comments near the relevant code,
 (2) function argument names are not repeated in comments, and
 (3) examples are defined in R code, not comments.
 It is also easy to define a new syntax.
URL: https://github.com/tdhock/inlinedocs
BugReports: https://github.com/tdhock/inlinedocs/issues
Depends: methods, utils, R (>= 2.9)
License: GPL-2 | GPL-3
LazyLoad: yes
Encoding: UTF-8
Suggests: future.apply, future, R.methodsS3
NeedsCompilation: no
Packaged: 2023-10-17 21:32:29 UTC; tdhock
Author: Toby Dylan Hocking [aut, cre],
  Keith Ponting [aut],
  Thomas Wutzler [aut],
  Philippe Grosjean [aut],
  Markus Müller [aut],
  R Core Team [ctb, cph]
Maintainer: Toby Dylan Hocking <toby.hocking@r-project.org>
Repository: CRAN
Date/Publication: 2023-10-18 18:30:02 UTC
Built: R 4.6.0; ; 2026-04-26 20:16:57 UTC; unix

foo <- function
### This description
###
### should make it into the docs.
(x){
}

.result <- list(foo=list(
  description="This description\n\nshould make it into the docs.",
  definition="foo <- function\n### This description\n###\n### should make it into the docs.\n(x){\n}",
  format="",
  "item{x}"="x ",
  title="foo"))

fermat.test <- function
### Test an integer for primality using Fermat's Little Theorem.
(n ##<< The integer to test.
 ){
  a <- floor(runif(1,min=1,max=n))
  a^n %% n == a
### Whether the integer passes the Fermat test for a randomized
### \eqn{0<a<n}.
}
is.pseudoprime <- function # Check an integer for pseudo-primality.
### A number is pseudo-prime if it is probably prime, the basis of
### which is the probabalistic Fermat test; if it passes two such
### tests, the chances are better than 3 out of 4 that \eqn{n} is
### prime.
##references<< Abelson, Hal; Jerry Sussman, and Julie
##Sussman. Structure and Interpretation of Computer
##Programs. Cambridge: MIT Press, 1984.
(n,    ##<< Integer to test for pseudoprimality.
 times
### Number of Fermat tests to perform. More tests are more likely to
### give accurate results.
 ){
  if(times==0)TRUE
  ##seealso<< \code{\link{fermat.test}}
  else if(fermat.test(n)) is.pseudoprime(n,times-1)
  else FALSE
### logical TRUE if n is probably prime.
}
try.several.times <- structure(function
### Test an integer for primality using different numbers of tests.
(n,    ##<< integer to test for primality.
 times ##<< vector of number of tests to try.
 ){
  is.prime <- sapply(times,function(t)is.pseudoprime(n,t))
  ##value<< data.frame with columns:
  data.frame(times, ##<< number of Fermat tests.
             is.prime, ##<< TRUE if probably prime
             n) ##<< Integer tested.
  ##end<<
},ex=function(){
  try.several.times(6,1:5)
  try.several.times(5,1:5)
})
setClass("DocLink", # Link documentation among related functions
### The \code{DocLink} class provides the basis for hooking together
### documentation of related classes/functions/objects. The aim is that
### documentation sections missing from the child are inherited from
### the parent class.
    representation(name = "character", ##<< name of object
                   created = "character", ##<< how created
                   parent = "character", ##<< parent class or NA
                   code = "character", ##<< actual source lines
                   description = "character") ##<< preceding description block
         )

.result <- list(
  fermat.test = list(
    definition = "fermat.test <- function\n### Test an integer for primality using Fermat's Little Theorem.\n(n ##<< The integer to test.\n ){\n  a <- floor(runif(1,min=1,max=n))\n  a^n %% n == a\n### Whether the integer passes the Fermat test for a randomized\n### \\eqn{0<a<n}.\n}",
    description = "Test an integer for primality using Fermat's Little Theorem.",
    value = "Whether the integer passes the Fermat test for a randomized\n\\eqn{0<a<n}.",
    `item{n}` = "The integer to test.",
    format = "",
    title = "fermat test"),
  is.pseudoprime = list(
    definition = "is.pseudoprime <- function # Check an integer for pseudo-primality.\n### A number is pseudo-prime if it is probably prime, the basis of\n### which is the probabalistic Fermat test; if it passes two such\n### tests, the chances are better than 3 out of 4 that \\eqn{n} is\n### prime.\n##references<< Abelson, Hal; Jerry Sussman, and Julie\n##Sussman. Structure and Interpretation of Computer\n##Programs. Cambridge: MIT Press, 1984.\n(n,    ##<< Integer to test for pseudoprimality.\n times\n### Number of Fermat tests to perform. More tests are more likely to\n### give accurate results.\n ){\n  if(times==0)TRUE\n  ##seealso<< \\code{\\link{fermat.test}}\n  else if(fermat.test(n)) is.pseudoprime(n,times-1)\n  else FALSE\n### logical TRUE if n is probably prime.\n}",
    description = "A number is pseudo-prime if it is probably prime, the basis of\nwhich is the probabalistic Fermat test; if it passes two such\ntests, the chances are better than 3 out of 4 that \\eqn{n} is\nprime.",
    `item{times}` = "Number of Fermat tests to perform. More tests are more likely to\ngive accurate results.",
    value = "logical TRUE if \\code{n} is probably prime.",
    references = "Abelson, Hal; Jerry Sussman, and Julie\nSussman. Structure and Interpretation of Computer\nPrograms. Cambridge: MIT Press, 1984.",
    `item{n}` = "Integer to test for pseudoprimality.",
    seealso = "\\code{\\link{fermat.test}}",
    title = "Check an integer for pseudo-primality.",
    format = ""),
  try.several.times = list(
    definition = "try.several.times <- structure(function\n### Test an integer for primality using different numbers of tests.\n(n,    ##<< integer to test for primality.\n times ##<< vector of number of tests to try.\n ){\n  is.prime <- sapply(times,function(t)is.pseudoprime(n,t))\n  ##value<< data.frame with columns:\n  data.frame(times, ##<< number of Fermat tests.\n             is.prime, ##<< TRUE if probably prime\n             n) ##<< Integer tested.\n  ##end<<\n},ex=function(){\n  try.several.times(6,1:5)\n  try.several.times(5,1:5)\n})",
    description = "Test an integer for primality using different numbers of tests.",
    `item{n}` = "integer to test for primality.",
    `item{times}` = "vector of number of tests to try.",
    value = "data.frame with columns:\n\\item{times}{number of Fermat tests.}\n\\item{is.prime}{TRUE if probably prime}\n\\item{n}{Integer tested.}",
    format = "",
    title = "try several times",
    examples = "\ntry.several.times(6,1:5)\ntry.several.times(5,1:5)\n"),
  `DocLink-class` = list(
    `item{name}` = "name of object",
    `item{created}` = "how created",
    `item{parent}` = "parent class or NA", `item{code}` = "actual source lines",
    `item{description}` = "preceding description block",
    description = "The \\code{DocLink} class provides the basis for hooking together\ndocumentation of related classes/functions/objects. The aim is that\ndocumentation sections missing from the child are inherited from\nthe parent class.",
    title = "Link documentation among related functions",
    details = "Objects can be created by calls of the form \\code{new(DocLink ...)}",
    `section{Objects from the Class}` = "Objects can be created by calls of the form \\code{new(DocLink ...)}",
    seealso = "",
    alias = "DocLink"))

apply <- function # Apply Functions Over Array Margins
### Returns a vector or array or list of values obtained by applying a
### function to margins of an array or matrix.
(X, ##<< an array, including a matrix.
 MARGIN,
### the margin.
 FUN, 
### the function to be applied: see \sQuote{Details}. In the case of
### functions like \code{+}, \code{%*%}, etc., the function name
### must be backquoted or quoted.
 ... ##<< optional arguments to \code{FUN}.
 ){
  5
### test apply.
}

.result <-
  list(apply=list(title="Apply Functions Over Array Margins",
         description=paste("Returns a vector or array or list of values obtained by applying a",
           "function to margins of an array or matrix.",sep="\n"),
         "item{X}"="an array, including a matrix.",
         "item{MARGIN}"="the margin.",
         "item{FUN}"=paste("the function to be applied: see \\sQuote{Details}. In the case of",
           "functions like \\code{+}, \\code{%*%}, etc., the function name",
           "must be backquoted or quoted.",sep="\n"),
         "item{\\dots}"="optional arguments to \\code{FUN}.",
         value="test apply.",format="",
         definition="apply <- function # Apply Functions Over Array Margins\n### Returns a vector or array or list of values obtained by applying a\n### function to margins of an array or matrix.\n(X, ##<< an array, including a matrix.\n MARGIN,\n### the margin.\n FUN, \n### the function to be applied: see \\sQuote{Details}. In the case of\n### functions like \\code{+}, \\code{%*%}, etc., the function name\n### must be backquoted or quoted.\n ... ##<< optional arguments to \\code{FUN}.\n ){\n  5\n### test apply.\n}"))

filterTSeriesSSA <- function(
### Decompose a vector (i.e. time series) into spectral bands
series                      ##<< numeric vector: Input time series (no gaps!)
, borders.wl                ##<< list of numeric vectors: Borders of the different periodicity
                            ## bands to extract. Units are the sampling frequency of the series
                            ## (needs one  vector per step (see details)).
, M = rep(floor(length(series) / 3), times = n.steps)  ##<< integer (vector): Window length
                            ## or embedding dimension (see details and ?ssa) (in ssa() this parameter
                            ## is called L).
, n.comp = rep(40, times = n.steps)##<< integer (vector): Amount of SSA components to compute.
                            ## See the help of ssa (package Rssa) for details.
, harmonics=rep(0, times = n.steps)##<< integer (vector): How many harmonics to include in each
                            ## component (see details). No harmonics are used if set to 0 (default).
, tolerance.harmonics = 0.05##<< numeric fraction (0-1): Tolerance to use to determine the
                            ## width of the bands the harmonics are looked for in. The actual
                            ## width is calculated by multiplying the frequency of the "main"
                            ## oscillation with this ratio. Use higher values for oscillations
                            ## with few repetitions (and, hence, wider peaks in a spectrum) and lower
                            ## ones with those with many repetitions (and thus sharper peaks).
, var.thresh.ratio = 0.005  ##<< numeric fraction(0-1): Variance threshold below which eigentriples are
                            ## treated as "noise" and will not be included in the groups. The actual
                            ## threshold is calculated by multiplying the total variance of
                            ## the time series with this fraction.
, grouping = c('grouping.auto', 'groupSSANearestNeighbour')[1]##<< character string: Method to use for grouping
                            ##  the individual SSA eigentriples. 'grouping.auto' uses the function
                            ## of that name in package Rssa, 'groupSSANearestNeighbour' employs a rather crude scheme
                            ## based on finding pairs (or larger groups) in an euclidian
                            ## distance matrix of the reconstructions of all extracted SSA eigentriples.
                            ## See ?grouping.auto or ?groupSSANearestNeighbour for details.
, groupingMethod = 'wcor'   ## character string: Method to use for grouping with the grouping.auto
                            ## function.
, repeat.extr = rep(1, times = length(borders.wl))##<< integer value/vector: How often to repeat the
                            ## extraction. If the respective value is > 1 than the result of the extraction
                            ## is again subject to spectral decomposition/filtering for n times and only
                            ## the (filtered) result is treated as the actual band (see details).
, recstr.type = 'subtraction' ##<< string: How to determine the high frequency residuals.
                            ## If == 'subtraction', the high frequency signal is computed by subtracting
                            ## all other signals from the original series (see details). For all other
                            ## values only extracted eigentriples with high frequencies are grouped
                            ## in this band.
, pad.series = c(0, 0)      ##<< integer vector (length 2): Length of the part of the series to use for
                            ## padding at the start (first value) and at the end of the series. Values
                            ## of zero (default) cause no padding.
, SSA.methods = c('nutrlan', 'propack', 'eigen', 'svd')  ##<< character vector: Methods to use for the
                            ## SSA computation. First the first method is tried, when convergence
                            ## fails, the second is used and so on. See the help of ssa() in
                            ## package Rssa for details on the methods. It is preferable to use more
                            ## than one method as some methods (especially nutrlan) in some cases do not
                            ## converge. The last two methods are relatively slow.
, center.series = TRUE      ##<< logical: Whether to center the series around zero prior to the computation.
                            ## The (subtracted) mean will be added to the long term 'trend' component,
                            ## e.g. to the step containing an Inf value in  borders.wl. Not centering
                            ## of the series may cause erroneous trend extraction in some cases!
, call.freq = quote(calcFrequency(series.t)) ##<< 'quoted' function call : call to a function to compute
                            ## the frequency of the 'major' oscillation present in some time series.
                            ## This is used to compute the frequency of the (grouped) SSA eigentriples.
                            ## See the help for 'calcFrequency' for details of the default mechanism.
, n.steps = switch(class(borders.wl),list=length(borders.wl), dim(borders.wl)[2]) ##<< integer:
                            ##  Amount of steps in the process. This argument is only kept
                            ## for backwards compatibility. Do not supply or change any values!
, plot.spectra = FALSE      ##<< logical: Whether to plot pseudo spectra for the different steps.
, second.axis = TRUE        ##<< logical: Whether to plot a second axis with period units
, open.plot = TRUE          ##<< logical: Whether to open a new plotting window for the plots. Set this to
                            ##   FALSE and open and set up a device prior to running the function to specify
                            ##   or change the device options.
, print.stat = TRUE         ##<< logical: whether to print status information during the calculations.
, xlim = c()                ##<< numeric vector: x-limits for the plotted spectra. If not supplied
                            ## it goes from 1 / n....0,5.
, debugging = FALSE         ##<< logical: if TRUE, workspaces are saved that can be used for debugging
                            ##   non convergence cases that do not cause R errors but may indicate
                            ##   a possible error in the settings, data or code.
, ...                       ##<< miscellaneous: further arguments passed to the plotting routines.
) {
  5
### Numeric 5.
}

.result <-
 list(filterTSeriesSSA = list(definition = "filterTSeriesSSA <- function(\n### Decompose a vector (i.e. time series) into spectral bands\nseries                      ##<< numeric vector: Input time series (no gaps!)\n, borders.wl                ##<< list of numeric vectors: Borders of the different periodicity\n                            ## bands to extract. Units are the sampling frequency of the series\n                            ## (needs one  vector per step (see details)).\n, M = rep(floor(length(series) / 3), times = n.steps)  ##<< integer (vector): Window length\n                            ## or embedding dimension (see details and ?ssa) (in ssa() this parameter\n                            ## is called L).\n, n.comp = rep(40, times = n.steps)##<< integer (vector): Amount of SSA components to compute.\n                            ## See the help of ssa (package Rssa) for details.\n, harmonics=rep(0, times = n.steps)##<< integer (vector): How many harmonics to include in each\n                            ## component (see details). No harmonics are used if set to 0 (default).\n, tolerance.harmonics = 0.05##<< numeric fraction (0-1): Tolerance to use to determine the\n                            ## width of the bands the harmonics are looked for in. The actual\n                            ## width is calculated by multiplying the frequency of the \"main\"\n                            ## oscillation with this ratio. Use higher values for oscillations\n                            ## with few repetitions (and, hence, wider peaks in a spectrum) and lower\n                            ## ones with those with many repetitions (and thus sharper peaks).\n, var.thresh.ratio = 0.005  ##<< numeric fraction(0-1): Variance threshold below which eigentriples are\n                            ## treated as \"noise\" and will not be included in the groups. The actual\n                            ## threshold is calculated by multiplying the total variance of\n                            ## the time series with this fraction.\n, grouping = c('grouping.auto', 'groupSSANearestNeighbour')[1]##<< character string: Method to use for grouping\n                            ##  the individual SSA eigentriples. 'grouping.auto' uses the function\n                            ## of that name in package Rssa, 'groupSSANearestNeighbour' employs a rather crude scheme\n                            ## based on finding pairs (or larger groups) in an euclidian\n                            ## distance matrix of the reconstructions of all extracted SSA eigentriples.\n                            ## See ?grouping.auto or ?groupSSANearestNeighbour for details.\n, groupingMethod = 'wcor'   ## character string: Method to use for grouping with the grouping.auto\n                            ## function.\n, repeat.extr = rep(1, times = length(borders.wl))##<< integer value/vector: How often to repeat the\n                            ## extraction. If the respective value is > 1 than the result of the extraction\n                            ## is again subject to spectral decomposition/filtering for n times and only\n                            ## the (filtered) result is treated as the actual band (see details).\n, recstr.type = 'subtraction' ##<< string: How to determine the high frequency residuals.\n                            ## If == 'subtraction', the high frequency signal is computed by subtracting\n                            ## all other signals from the original series (see details). For all other\n                            ## values only extracted eigentriples with high frequencies are grouped\n                            ## in this band.\n, pad.series = c(0, 0)      ##<< integer vector (length 2): Length of the part of the series to use for\n                            ## padding at the start (first value) and at the end of the series. Values\n                            ## of zero (default) cause no padding.\n, SSA.methods = c('nutrlan', 'propack', 'eigen', 'svd')  ##<< character vector: Methods to use for the\n                            ## SSA computation. First the first method is tried, when convergence\n                            ## fails, the second is used and so on. See the help of ssa() in\n                            ## package Rssa for details on the methods. It is preferable to use more\n                            ## than one method as some methods (especially nutrlan) in some cases do not\n                            ## converge. The last two methods are relatively slow.\n, center.series = TRUE      ##<< logical: Whether to center the series around zero prior to the computation.\n                            ## The (subtracted) mean will be added to the long term 'trend' component,\n                            ## e.g. to the step containing an Inf value in  borders.wl. Not centering\n                            ## of the series may cause erroneous trend extraction in some cases!\n, call.freq = quote(calcFrequency(series.t)) ##<< 'quoted' function call : call to a function to compute\n                            ## the frequency of the 'major' oscillation present in some time series.\n                            ## This is used to compute the frequency of the (grouped) SSA eigentriples.\n                            ## See the help for 'calcFrequency' for details of the default mechanism.\n, n.steps = switch(class(borders.wl),list=length(borders.wl), dim(borders.wl)[2]) ##<< integer:\n                            ##  Amount of steps in the process. This argument is only kept\n                            ## for backwards compatibility. Do not supply or change any values!\n, plot.spectra = FALSE      ##<< logical: Whether to plot pseudo spectra for the different steps.\n, second.axis = TRUE        ##<< logical: Whether to plot a second axis with period units\n, open.plot = TRUE          ##<< logical: Whether to open a new plotting window for the plots. Set this to\n                            ##   FALSE and open and set up a device prior to running the function to specify\n                            ##   or change the device options.\n, print.stat = TRUE         ##<< logical: whether to print status information during the calculations.\n, xlim = c()                ##<< numeric vector: x-limits for the plotted spectra. If not supplied\n                            ## it goes from 1 / n....0,5.\n, debugging = FALSE         ##<< logical: if TRUE, workspaces are saved that can be used for debugging\n                            ##   non convergence cases that do not cause R errors but may indicate\n                            ##   a possible error in the settings, data or code.\n, ...                       ##<< miscellaneous: further arguments passed to the plotting routines.\n) {\n  5\n### Numeric 5.\n}",
     description = "Decompose a vector (i.e. time series) into spectral bands",
     value = "Numeric 5.", `item{series}` = "numeric vector: Input time series (no gaps!)",
     `item{borders.wl}` = "list of numeric vectors: Borders of the different periodicity\nbands to extract. Units are the sampling frequency of the series\n(needs one  vector per step (see details)).",
     `item{M}` = "integer (vector): Window length\nor embedding dimension (see details and ?ssa) (in ssa() this parameter\nis called L).",
     `item{n.comp}` = "integer (vector): Amount of SSA components to compute.\nSee the help of ssa (package Rssa) for details.",
     `item{harmonics}` = "integer (vector): How many harmonics to include in each\ncomponent (see details). No harmonics are used if set to 0 (default).",
     `item{tolerance.harmonics}` = "numeric fraction (0-1): Tolerance to use to determine the\nwidth of the bands the harmonics are looked for in. The actual\nwidth is calculated by multiplying the frequency of the \"main\"\noscillation with this ratio. Use higher values for oscillations\nwith few repetitions (and, hence, wider peaks in a spectrum) and lower\nones with those with many repetitions (and thus sharper peaks).",
     `item{var.thresh.ratio}` = "numeric fraction(0-1): Variance threshold below which eigentriples are\ntreated as \"noise\" and will not be included in the groups. The actual\nthreshold is calculated by multiplying the total variance of\nthe time series with this fraction.",
     `item{grouping}` = "character string: Method to use for grouping\nthe individual SSA eigentriples. 'grouping.auto' uses the function\nof that name in package Rssa, 'groupSSANearestNeighbour' employs a rather crude scheme\nbased on finding pairs (or larger groups) in an euclidian\ndistance matrix of the reconstructions of all extracted SSA eigentriples.\nSee ?grouping.auto or ?groupSSANearestNeighbour for details.",
     `item{repeat.extr}` = "integer value/vector: How often to repeat the\nextraction. If the respective value is > 1 than the result of the extraction\nis again subject to spectral decomposition/filtering for n times and only\nthe (filtered) result is treated as the actual band (see details).",
     `item{recstr.type}` = "string: How to determine the high frequency residuals.\nIf == 'subtraction', the high frequency signal is computed by subtracting\nall other signals from the original series (see details). For all other\nvalues only extracted eigentriples with high frequencies are grouped\nin this band.",
     `item{pad.series}` = "integer vector (length 2): Length of the part of the series to use for\npadding at the start (first value) and at the end of the series. Values\nof zero (default) cause no padding.",
     `item{SSA.methods}` = "character vector: Methods to use for the\nSSA computation. First the first method is tried, when convergence\nfails, the second is used and so on. See the help of ssa() in\npackage Rssa for details on the methods. It is preferable to use more\nthan one method as some methods (especially nutrlan) in some cases do not\nconverge. The last two methods are relatively slow.",
     `item{center.series}` = "logical: Whether to center the series around zero prior to the computation.\nThe (subtracted) mean will be added to the long term 'trend' component,\ne.g. to the step containing an Inf value in  borders.wl. Not centering\nof the series may cause erroneous trend extraction in some cases!",
     `item{call.freq}` = "'quoted' function call : call to a function to compute\nthe frequency of the 'major' oscillation present in some time series.\nThis is used to compute the frequency of the (grouped) SSA eigentriples.\nSee the help for 'calcFrequency' for details of the default mechanism.",
     `item{n.steps}` = "integer:\nAmount of steps in the process. This argument is only kept\nfor backwards compatibility. Do not supply or change any values!",
     `item{plot.spectra}` = "logical: Whether to plot pseudo spectra for the different steps.",
     `item{second.axis}` = "logical: Whether to plot a second axis with period units",
     `item{open.plot}` = "logical: Whether to open a new plotting window for the plots. Set this to\nFALSE and open and set up a device prior to running the function to specify\nor change the device options.",
     `item{print.stat}` = "logical: whether to print status information during the calculations.",
     `item{xlim}` = "numeric vector: x-limits for the plotted spectra. If not supplied\nit goes from 1 / n....0,5.",
     `item{debugging}` = "logical: if TRUE, workspaces are saved that can be used for debugging\nnon convergence cases that do not cause R errors but may indicate\na possible error in the settings, data or code.",
     `item{\\dots}` = "miscellaneous: further arguments passed to the plotting routines.",
     format = "", title = "filterTSeriesSSA"))

.parsers <- inlinedocs::test.parsers

helloWorld <- function
### function for which an example should be added
( ){
  cat("Hello World!\n")
  invisible(NULL)
  ### None (invisible NULL)
}

attr(helloWorld,"ex") <- function(){
	# all text including comments inside this block 
	# should go to the examples section of 
	# function helloWorld
	helloWorld()	# prints Hello World
}

.tmp.f <- function(
	### some non-exported interactive debugging code.
){
	# first source test.R from inlinedocs
	fname <- file.path("inst","testfiles","attrExamples.R")
	#library(debug); mtrace(extract.file.parse)
	#save.test.result(fname)
	#test.file(fname)
}

.result <- 
	list(helloWorld = list(definition = "helloWorld <- function\n### function for which an example should be added\n( ){\n  cat(\"Hello World!\\n\")\n  invisible(NULL)\n  ### None (invisible NULL)\n}",  
			description = "function for which an example should be added",  
			value = "None (invisible NULL)", examples = "\n# all text including comments inside this block \n# should go to the examples section of \n# function helloWorld\nhelloWorld()\t# prints Hello World\n",
               format="",title="helloWorld"))

CalculateSampleCovariance <- function(x, y, verbose = TRUE) {
  # Computes the sample covariance between two vectors.
  #
  # Args:
  #   x: One of two vectors whose sample covariance is to be calculated.
  #   y: The other vector. x and y must have the same length, greater than one,
  #      with no missing values.
  #   verbose: If TRUE, prints sample covariance; if not, not. Default is TRUE.
  #
  # Returns:
  #   The sample covariance between x and y.
  n <- length(x)
  # Error handling
  if (n <= 1 || n != length(y)) {
    stop("Arguments x and y have invalid lengths: ",
         length(x), " and ", length(y), ".")
  }
  if (TRUE %in% is.na(x) || TRUE %in% is.na(y)) {
    stop(" Arguments x and y must not have missing values.")
  }
  covariance <- var(x, y)
  if (verbose)
    cat("Covariance = ", round(covariance, 4), ".\n", sep = "")
  return(covariance)
}

google <- function(src,...){
  # Extract docs from google header comments.
  #
  # Args:
  # src: lines of code of the function source.
  #
  # Returns:
  # An inner Documentation List.
  i <- 2
  docs <- list()
  mode <- "description"
  comment.pattern <- "\\W*#\\W*"
  while(grepl(comment.pattern,line <- src[i])){
    content <- gsub(comment.pattern,"",line)
    if(grepl("Returns:",line)){
      mode <- "value"
    }else if(mode=="value"){
      docs$value <- c(docs$value,content)
    }
    if(grepl("Args:",line)){
      mode <- "args"
    }else if(mode=="args"){
      prefix <- gsub(":.*","",content)
      if(grepl(":",content))lname <- sprintf("item{%s}",prefix)
      suffix <- gsub(".*:\\s*","",content)
      docs[[lname]] <- c(docs[[lname]],suffix)
    }
    if(mode=="description"){
      docs$description <- c(docs$description,content)
    }
    i <- i+1
  }
  lapply(docs,function(x)gsub("\\s*$","",paste(x,collapse="\n")))
}
.parsers <- list(google=inlinedocs::forfun(google))

#src <- getSource(CalculateSampleCovariance)
#google(src)
.dontcheck <- TRUE

.result <-
  list(google=list(description="Extract docs from google header comments.",
         `item{src}`="lines of code of the function source.",
         value="An inner Documentation List."),
       CalculateSampleCovariance=list(
         description="Computes the sample covariance between two vectors.",
         `item{x}`="One of two vectors whose sample covariance is to be calculated.",
         `item{y}`="The other vector. x and y must have the same length, greater than one,\nwith no missing values.",
         `item{verbose}`="If TRUE, prints sample covariance; if not, not. Default is TRUE.",
         value="The sample covariance between x and y."))

test <- function
### the desc
(x,
### the first argument
 y ##<< another argument
 ){
  5
### the return value
##seealso<< foobar
}

.result <- 
 list(test = list(definition = "test <- function\n### the desc\n(x,\n### the first argument\n y ##<< another argument\n ){\n  5\n### the return value\n##seealso<< foobar\n}",  
     description = "the desc", `item{x}` = "the first argument",  
     value = "the return value", `item{y}` = "another argument",  
     seealso = "foobar", format = "", title = "test")) 

### Prefix for code comments used with grep and gsub.
prefix <- "^### "

decomment <- function
### Remove comment prefix and join lines of code to form a
### documentation string. We use base::gsub and base::paste.
(comments
### Character vector of prefixed comment lines.
 ){
  paste(gsub(prefix,"",comments),collapse=" ")
### String without prefixes or newlines.
}

### Necessary fields in DESCRIPTION, otherwise error.
desc.fields <- c("Package","Maintainer","Author","Version",
            "License","Title","Description")
### Default DESCRIPTION, written if it doesn't exist.
empty.description <- matrix("",ncol=length(desc.fields),dimnames=list(NULL,desc.fields))

package.skeleton.dx <- function # Package skeleton deluxe
### Automates more of the setup process for a new source
### package. After inspecting the specified R code files to find
### inline documentation, it calls the standard package.skeleton
### function, which creates bare Rd files. The inline documentation is
### added to these Rd files and then these files are copied to
### ../man. It will overwrite files in the pkgdir/man directory.
(pkgdir="..",
### package directory where the DESCRIPTION file lives. Your code
### should be in pkgdir/R. We will setwd to pkgdir/R for the duration
### of the function, then switch back to where you were previously.
 code_files=NULL,
### Character vector with the names of the R code files, to be passed
### to package.skeleton, and also inspected for inline
### documentation. NULL means all files ending in .R.
 check.type=""
### Value indicating whether or not to check the package after
### documentation is built. Anything other than "" (the default) will
### check the package. "noex" means check the package without running
### examples, only tests (useful for debugging if your tests/examples
### take a long time).
 ){
  chdir <- file.path(pkgdir,"R")
  old.wd <- setwd(chdir)
  on.exit(setwd(old.wd))

  descfile <- file.path("..","DESCRIPTION")
  if(!file.exists(descfile)){
    write.dcf(empty.description,descfile)
    stop("Need ",descfile,"; please fill that in and try again")
  }

  ## Read description and check for errors
  desc <- read.dcf(descfile)
  for(f in desc.fields){
    if(! f %in% colnames(desc))stop("Need ",f," in ",descfile)
    if(desc[,f]=="")stop("Need a value for ",f," in ",descfile)
  }

  ## extract docs from each file
  if(is.null(code_files))code_files <- Sys.glob("*.R")
  docs <- list()
  for(cf in code_files){
    L <- extract.docs.file(cf,check!="noex")
    for(N in names(L))docs[[N]] <- L[[N]]
  }
  for(i in names(docs)){
    docs[[i]]$author <- desc[,"Maintainer"]
    if(! 'title' %in% names(docs[[i]]))
      docs[[i]]$title <- gsub("[._]"," ",i)
  }
  name <- desc[,"Package"]
  details <- paste(paste(colnames(desc),": \\tab ",desc,"\\cr",sep=""),
                   collapse="\n")
  docs[[paste(name,"-package",sep="")]] <-
    list(title=desc[,"Title"],
         description=desc[,"Description"],
         `tabular{ll}`=details,
         author=desc[,"Maintainer"])
  ## Make package skeleton and edit Rd files
  unlink(name,recursive=TRUE)
  package.skeleton(name,code_files=code_files)
  cat("Modifying files automatically generated by package.skeleton:\n")
  for(N in names(docs))modify.Rd.file(N,name,docs)
  file.copy(file.path(name,'man'),"..",recursive=TRUE)
  unlink(name,recursive=TRUE)

  if(check!=""){
    Rdir <- setwd(file.path("..",".."))
    cdir <- basename(dirname(Rdir))
    system(paste("R CMD check",cdir))
  }
  ## rebuild examples if we didn't test them:
  if(check=="noex")package.skeleton.dx(pkgdir,code_files,"")
}

modify.Rd.file <- structure(function
                            ### Add inline documentation from comments to an Rd file
                            ### automatically-generated by package.skeleton.
(N,
  ### Name of function/file to which we will add documentation.
  pkg,
  ### Package name.
  docs
  ### Named list of documentation in extracted comments.
){
  fb <- paste(N,".Rd",sep="")
  f <- file.path(pkg,'man',fb)
  ## If there are no significant docs in the comments then the object
  ## should still be documented, by writing the file by hand in the
  ## man directory. This will write a blank Rd file if none exists, so
  ## it's easy to get started.
  if((length(docs[[N]])<3) &&
       file.exists(file.path("..","man",fb))){
    unlink(f)
    return()
  }
  cat(N,":",sep="")
  d <- docs[[N]]
  dlines <- readLines(f)

  ## cut out alias line if we are in the package file and there is a
  ## matching function
  if(length(grep("-package$",N)))
    dlines <- dlines[-grep(paste("alias[{]",N,sep=""),dlines)-1]

  ## cut out all comments {} interferes with regex matching
  dlines <- dlines[-grep("^[%~]",dlines)]

  ## cut out a couple of sections that cause warnings
  o <- grep("Optionally",dlines)
  if(length(o))dlines <- dlines[-(o:(o+1))]
  ## delete examples til the end of the file (also includes keywords)
  dlines <- dlines[1:(tail(grep("examples[{]$",dlines),1)-1)]
  ## add back a minimal examples section to find and replace
  dlines <- c(dlines,"\\examples{}")

  ## Find and replace based on data in d
  txt <- paste(dlines,collapse="\n")
  for(torep in names(d)){
    cat(" ",torep,sep="")
    FIND1 <- gsub("\\\\","\\\\\\\\",torep)
    FIND <- paste(gsub("([{}])","\\\\\\1",FIND1),"[{][^}]*[}]",sep="")
    ## need to escape backslashes for faithful copying of the comments
    ## to the Rd file:
    REP <- paste(FIND1,"{",gsub("\\\\","\\\\\\\\",d[[torep]]),"}",sep="")
    ## escape percent signs in R code:
    REP <- gsub("%","\\\\\\\\%",REP)
    txt <- gsub(FIND,REP,txt)
  }

  ## Fix usage
  m <- regexpr("usage[{][^}]*[}]",txt)
  Mend <- m+attr(m,"match.length")
  utxt <- substr(txt,m,Mend)
  if(length(grep("usage[{]data",utxt)))
    utxt <- gsub("data[(]([^)]*)[)]","\\1",utxt)
  ## add another backslash due to bug in package.skeleton
  txt <- paste(substr(txt,1,m-1),
               gsub("\\\\","\\\\\\\\",utxt),
               substr(txt,Mend+1,nchar(txt)),
               sep="")
  ## This doesn't work if there are quotes in the default values:
  ## gsub(",",paste("\n",paste(rep(" ",l=nchar(N)-1),collapse="")),utxt)
  cat(txt,file=f)
  cat("\n")
}, ex=function(){
  cat("\\")
})

extract.docs.file <- function # Extract documentation from a file
### Parse an R code file and extract inline documentation from
### comments around each function.
(code.file,
### The R code file to parse.
 write.examples=TRUE
### Gather examples from test files?
 ){
  code <- readLines(code.file)
  comment.lines <- grep(prefix,code)
  e <- new.env()
  old <- options(keep.source.pkgs=TRUE)
  r <- try(sys.source(code.file,e),TRUE)
  if(class(r)=="try-error")
    stop("source ",code.file," failed with error:\n",r)
  options(old)
  objs <- sapply(ls(e),get,e,simplify=FALSE)
  extract.docs <- function(on){
    res <- try({
      o <- objs[[on]]
      doc <- if("function"%in%class(o)){
        tdoc <- extract.docs.fun(o)
        if(write.examples){ ## do not get examples from test files.
          tfile <- file.path("..","tests",paste(on,".R",sep=""))
          if(file.exists(tfile))
            tdoc[["examples"]] <- paste(readLines(tfile),collapse="\n")
        }
        tdoc
      }else list()
      ## Take the line before the first occurence of the variable
      defined.on <- grep(paste("^",on,sep=""),code)[1]-1
      if(!"description"%in%names(doc) && defined.on%in%comment.lines){
        comments.before <- comment.lines[comment.lines<=defined.on]
        these.comment.lines <- if(length(comments.before)==1)comments.before else{
          diffs <- diff(comments.before)
          comments.before[max(which(diffs>1))+1]:defined.on
        }
        doc$description <- decomment(code[these.comment.lines])
      }
      doc
    },FALSE)
    if(class(res)=="try-error"){
      cat("Failed to extract docs for: ",on,"\n\n")
      list()
    }
    else res
  }
  res <- sapply(names(objs),extract.docs,simplify=FALSE)
  res
### named list of lists. Each element is the result of a call to
### extract.docs.fun, with names corresponding to functions found in
### the R code file.
}

extract.docs.fun <- function # Extract documentation from a function
### Given a function, return a list describing inline documentation in
### the source of that function (relies on source attr).
(fun
### The function to examine.
 ){
  res <- list()
  code <- attr(fun,"source")
  clines <- grep("^#",code)
  if(length(grep("#",code[1])))res$title <- gsub("[^#]*#(.*)","\\1",code[1])
  if(length(clines)==0)return(res) ## no comments found
  bounds <- which(diff(clines)!=1)
  starts <- c(1,bounds+1)
  ends <- c(bounds,length(clines))
  for(i in seq_along(starts)){
    start <- clines[starts[i]]
    end <- clines[ends[i]]
    lab <- if(end+1==length(code))"value"
    else if(start==2)"description"
    else {
      arg <- gsub("^[ (]*","",code[start-1])
      arg <- gsub("^([^=,]*)[=,].*","\\1",arg)
      arg <- gsub("...","\\dots",arg,fixed=TRUE) ##special case for dots
      paste("item{",arg,"}",sep="")
    }
    res[[lab]] <- decomment(code[start:end])
  }
  ##details<<
  ## For simple functions/arguments, the argument may also be documented by
  ## appending ##<< comments on the same line as the argument. For those who
  ## wish to become confused, any following ### comment lines will be appended.
  arg.pat <- "^\\s*\\(?\\s*([\\w\\.]+).*##<<\\s*(\\S.*?)\\s*$"
  for ( k in 2:length(code) ){
    if ( 0 < length(grep(arg.pat,code[k],perl=TRUE)) ){
      arg <- gsub(arg.pat,"\\\\item\\{\\1\\}",code[k],perl=TRUE)
      comment <- gsub(arg.pat,"\\2",code[k],perl=TRUE);
      res[[arg]] <-
        if ( is.null(res[[arg]]) )comment
        else paste(comment,res[[arg]],sep=" ")
    }
  }

  skeleton.fields <- c("alias","details","keyword","references","author",
                       "note","seealso","value")
  ##details<<
  ## Additionally, contiguous sections of ## comment lines beginning with
  ## xxx<< (where xxx is one of the "other" fields: alias, details, keyword,
  ## references, author, note, seealso or value) are accumulated and inserted in
  ## the relevant part of the .Rd file.
  ##
  ## In the case of value, the extra information is appended to that from
  ## any final ### comment lines.

  ## but this should not appear, because separated by a blank line
  extra.regexp <- paste("^\\s*##<<(",paste(skeleton.fields,collapse="|"),
                        ")\\s*(.*)$",sep="")
  starts.extra <- grep(extra.regexp,code,perl=TRUE)
  cont.re <- "^\\s*##\\s*";
  for ( start in starts.extra ){
    line <- code[start]
    field <- gsub(extra.regexp,"\\1",line,perl=TRUE)
    payload <- gsub(extra.regexp,"\\2",line,perl=TRUE)
    if ( start < length(code) ){
      for ( k in (start+1):length(code) ){
        if ( k %in% starts.extra        # go on to next extra section
            || 0 == length(grep(cont.re,code[k])) ){ # blank line or code ends
          if ( "alias" == field ){
            ##note<< Alias extras are automatically split at new lines.
            payload <- gsub("\\n+",paste("\\}\n\\",field,"\\{",sep=""),
                            payload,perl=TRUE)
          } else if ("keyword" == field ){
            ##keyword<< documentation utilities
            ##note<< Keyword extras are auto-split at white space.
            payload <- gsub("\\s+",paste("\\}\n\\",field,"\\{",sep=""),
                            payload,perl=TRUE)
          }
          ##details<< Each separate extra section appears as a new paragraph
          ## except that empty sections (no matter how many lines) are ignored.
          if ( 0 == length(grep("^\\s*$",payload,perl=TRUE)) )
            res[[field]] <-
              if ( is.null(res[[field]]) )payload
              else res[[field]] <- paste(res[[field]], payload, sep="\n\n")
          break;
        } else {
          payload <- paste(payload,sub(cont.re,"",code[k],perl=TRUE),sep="\n")
        }
      }
    }
  }
  res
### Named list of character strings extracted from comments. For each
### name N we will look for N\{...\} in the Rd file and replace it
### with the string in this list (implemented in modify.Rd.file).
}

.result <- list(
  decomment = list(
    format="",
    title="decomment",
    description = "Remove comment \\code{\\link{prefix}} and join lines of code to form a
documentation string. We use \\code{\\link[base]{gsub}} and \\code{\\link[base]{paste}}.",
    `item{comments}` = "Character vector of prefixed comment lines.",
    value = "String without prefixes or newlines."),
  empty.description = list(
    format="",
    title="empty description",
    description = "Default DESCRIPTION, written if it doesn't exist."),
  extract.docs.file = list(
    title = "Extract documentation from a file",
    format="",
    description = "Parse an R code file and extract inline documentation from\ncomments around each function.",
    `item{code.file}` = "The R code file to parse.", `item{write.examples}` = "Gather examples from test files?",
    value = "named list of lists. Each element is the result of a call to\n\\code{\\link{extract.docs.fun}}, with names corresponding to functions found in\nthe R code file."),
  extract.docs.fun = list(
    format="",
    title = "Extract documentation from a function", description = "Given a function, return a list describing inline documentation in\nthe source of that function (relies on source attr).",
    `item{fun}` = "The function to examine.", value = "Named list of character strings extracted from comments. For each\nname N we will look for N\\{...\\} in the Rd file and replace it\nwith the string in this list (implemented in \\code{\\link{modify.Rd.file}}).",
    details = "For simple functions/arguments, the argument may also be documented by\nappending ##<< comments on the same line as the argument. For those who\nwish to become confused, any following ### comment lines will be appended.\n\nAdditionally, contiguous sections of ## comment lines beginning with\nxxx<< (where xxx is one of the \"other\" fields: alias, details, keyword,\nreferences, author, note, seealso or value) are accumulated and inserted in\nthe relevant part of the .Rd file.\n\nIn the case of value, the extra information is appended to that from\nany final ### comment lines.\n\nEach separate extra section appears as a new paragraph\nexcept that empty sections (no matter how many lines) are ignored.",
    note = "Alias extras are automatically split at new lines.\n\nKeyword extras are auto-split at white space.",
    keyword = "documentation}\n\\keyword{utilities"),
  desc.fields = list(
    format="",
    title="desc fields",
    description = "Necessary fields in DESCRIPTION, otherwise error."),
modify.Rd.file = list(
    examples="\ncat(\"\\\\\")\n",
    description = "Add inline documentation from comments to an Rd file\nautomatically-generated by package.skeleton.",
    format="",
    title="modify Rd file",
    `item{N}` = "Name of function/file to which we will add documentation.",
    `item{pkg}` = "Package name.", `item{docs}` = "Named list of documentation in extracted comments."),
  package.skeleton.dx = list(
    format="",
    title = "Package skeleton deluxe", description = "Automates more of the setup process for a new source\npackage. After inspecting the specified R code files to find\ninline documentation, it calls the standard package.skeleton\nfunction, which creates bare Rd files. The inline documentation is\nadded to these Rd files and then these files are copied to\n../man. It will overwrite files in the pkgdir/man directory.",
    `item{pkgdir}` = "package directory where the DESCRIPTION file lives. Your code\nshould be in pkgdir/R. We will setwd to pkgdir/R for the duration\nof the function, then switch back to where you were previously.",
    `item{code_files}` = "Character vector with the names of the R code files, to be passed\nto package.skeleton, and also inspected for inline\ndocumentation. NULL means all files ending in .R.",
    `item{check.type}` = "Value indicating whether or not to check the package after\ndocumentation is built. Anything other than \"\" (the default) will\ncheck the package. \"noex\" means check the package without running\nexamples, only tests (useful for debugging if your tests/examples\ntake a long time)."),
  prefix = list(
    description = "Prefix for code comments used with grep and gsub.",
    format="",
    title="prefix"))

soft.threshold <- structure(function # Soft-thresholding
### Apply the soft-threshold function to a vector.
(x,
### A vector of numeric data.
 lambda=1
### The largest absolute value that will be mapped to zero.
 ){
  stopifnot(lambda>=0)
  ifelse(abs(x)<lambda,0,x-sign(x)*lambda)
### The vector of observations after applying 
### the soft-thresholding function.
},ex=function(){
  x <- seq(-5,5,l=50)
  y <- soft.threshold(x)
  plot(x,y)
})

.result <- 
 list(soft.threshold = list(definition = "soft.threshold <- structure(function # Soft-thresholding\n### Apply the soft-threshold function to a vector.\n(x,\n### A vector of numeric data.\n lambda=1\n### The largest absolute value that will be mapped to zero.\n ){\n  stopifnot(lambda>=0)\n  ifelse(abs(x)<lambda,0,x-sign(x)*lambda)\n### The vector of observations after applying \n### the soft-thresholding function.\n},ex=function(){\n  x <- seq(-5,5,l=50)\n  y <- soft.threshold(x)\n  plot(x,y)\n})",
     title = "Soft-thresholding",
        format="",
     description = "Apply the soft-threshold function to a vector.",  
     `item{x}` = "A vector of numeric data.",
     `item{lambda}`= "The largest absolute value that will be mapped to zero.",
     examples = "\nx <- seq(-5,5,l=50)\ny <- soft.threshold(x)\nplot(x,y)\n",  
     value = "The vector of observations after applying \nthe soft-thresholding function.")) 

simple <- function(src,...){#title a simple Parser Function
  noquotes <- gsub("([\"'`]).*\\1","",src)
  print(noquotes)
  comments <- grep("#",noquotes,value=TRUE)
  pat <- "[^#]*#([^ ]*) (.*)"
  tags <- gsub(pat,"\\1",comments)
  docs <- as.list(gsub(pat,"\\2",comments))
  names(docs) <- tags
  docs[tags!=""]#value all the tags with a single pound sign
}

.parsers <- list(simple=inlinedocs::forfun(simple))

testfun <- function(x,y,z){#item{x} the first arg
  a <- (x+y)*z # just a regular comment
  a #value the sum of the first two times the third
  #description a useless formula
}

.result <- list(
  testfun=list(
    `item{x}`="the first arg",
    value="the sum of the first two times the third",
    description="a useless formula"),
  simple=list(
    title="a simple Parser Function",
    value="all the tags with a single pound sign"))

.dontcheck <- TRUE # because of use of forfun here

myFun <- structure(

function # My function
  ### Fun. description
(
  x ##<< an argument
)
{
  x * 2
},

ex=function()
{
  x <- 5
  myFun(x)
})

.result <- 
 list(myFun = list(definition = "myFun <- structure(\n\nfunction # My function\n  ### Fun. description\n(\n  x ##<< an argument\n)\n{\n  x * 2\n},\n\nex=function()\n{\n  x <- 5\n  myFun(x)\n})",  
     description = "Fun. description", `item{x}` = "an argument",  
     title = "My function", format = "", examples = "\nx <- 5\nmyFun(x)\n")) 

ptf.macro.thetaSMi <- function(# bla bla bla bla
### bla bla bla (i
 clay 
### Vector of numericals. Clay content [%] of each soil layer / 
### horizon. 
##seealso<<\code{\link{ptf.macro.prefFlow}}, 
## \code{\link{ptf.macro}}.
##references<<Jarvis N., Lindahl, A., Messing, I., Stenemo, F., 
## Hollis, J., Reichenberger, S. & Dubus, I.G., 2007. Algorithm 
## to completely parameterise MACRO from basic soil property data. 
## Report DL21 of the FP6 EU-funded FOOTPRINT project 
## [www.eu-footprint.org], 18p.
## 
## Wosten J.H.M., Lilly A., Nemes A., 
## Le Bas C., 1999. Development and use of a database of hydraulic 
## properties of European soils. Geoderma 90:169-185.
){
  return( "Hello world" ) 
### The function returns a vector of thetaSMi values of the same 
### length as the vector of value provided to each parameter. 
### Unit of thetaSMi is [-] or [m3 of water.m-3 of bulk soil].
}

ptf.macro.prefFlow <- function
### foo
(
 ){}

ptf.macro <- function
### bar
(){
}

.result <- 
 list(ptf.macro = list(definition = "ptf.macro <- function\n### bar\n(){\n}",  
     description = "bar", format = "", title = "ptf macro"), ptf.macro.prefFlow = list( 
     definition = "ptf.macro.prefFlow <- function\n### foo\n(\n ){}",  
     description = "foo", format = "", title = "ptf macro prefFlow"),  
     ptf.macro.thetaSMi = list(definition = "ptf.macro.thetaSMi <- function(# bla bla bla bla\n### bla bla bla (i\n clay \n### Vector of numericals. Clay content [%] of each soil layer / \n### horizon. \n##seealso<<\\code{\\link{ptf.macro.prefFlow}}, \n## \\code{\\link{ptf.macro}}.\n##references<<Jarvis N., Lindahl, A., Messing, I., Stenemo, F., \n## Hollis, J., Reichenberger, S. & Dubus, I.G., 2007. Algorithm \n## to completely parameterise MACRO from basic soil property data. \n## Report DL21 of the FP6 EU-funded FOOTPRINT project \n## [www.eu-footprint.org], 18p.\n## \n## Wosten J.H.M., Lilly A., Nemes A., \n## Le Bas C., 1999. Development and use of a database of hydraulic \n## properties of European soils. Geoderma 90:169-185.\n){\n  return( \"Hello world\" ) \n### The function returns a vector of thetaSMi values of the same \n### length as the vector of value provided to each parameter. \n### Unit of thetaSMi is [-] or [m3 of water.m-3 of bulk soil].\n}",  
         description = "bla bla bla (i", `item{clay}` = "Vector of numericals. Clay content [%] of each soil layer / \nhorizon. ",  
         value = "The function returns a vector of thetaSMi values of the same \nlength as the vector of value provided to each parameter. \nUnit of thetaSMi is [-] or [m3 of water.m-3 of bulk soil].",  
         seealso = "\\code{\\link{ptf.macro.prefFlow}}, \n\\code{\\link{ptf.macro}}.",  
         references = "Jarvis N., Lindahl, A., Messing, I., Stenemo, F., \nHollis, J., Reichenberger, S. & Dubus, I.G., 2007. Algorithm \nto completely parameterise MACRO from basic soil property data. \nReport DL21 of the FP6 EU-funded FOOTPRINT project \n[www.eu-footprint.org], 18p.\n\nWosten J.H.M., Lilly A., Nemes A., \nLe Bas C., 1999. Development and use of a database of hydraulic \nproperties of European soils. Geoderma 90:169-185.",  
         title = "bla bla bla bla", format = "")) 

silly.example <- function
### this function does nothing in particular and does it very well
(
 ##title<<Simple function arguments
 first,         ##<< the first argument with a multi-line description
 ## which I really have to put here rather than explaining in the details.
 second=        ##<< the second argument with a list default value
 ## and descriptions of each of the elements
 ##describe<<
 list(this="that", ##<< whichness
      the="other", ##<< of the
      rhubarb="stew", ##<< why
      foo="bar"),
 ##end<<
 third ##<< an argument that does nothing
 )
{
  ##description<<why should I add to description?
  ##details<<
  ## if second is TRUE then first is returned
  if ( second ){
    ##alias<<Long silly alias
    res <- first
  } else {
    ##details<<
    ## if second is not TRUE then a list is returned
    ##describe<<The contents of the list are:
    res <- list(x=7, ##<< x coordinate
                z= ##<< z describes everything else
                ##describe<<
                list(colour="green", ##<< colour of line
                     width=2),     ##<< width of line
                ##end<<
                ## and this line should get into documentation for z
                y=10)##<< y coordinate
  }
  ##note<< a note
  ##references<< a reference
  ##seealso<< \code{\link{Silly-class}}
  ##keyword<<documentation utilities
  invisible(res)
### invisible something not unrelated to first
}

setClass("Silly", # S4 classes can be documented as well
### The Silly class does nothing much either
         ##details<< Put what you like in documentation details,
         ## but ideally reference construction methods.
         representation(forwards="function", ##<< forward operation
                        reverse="function", ##<< how to go backward
                        crashes="integer") ##<< how many crashes
         ) ##<< this comment is ignored as it is outside setClass expression

.result <- list(
  silly.example = list(
    definition = "silly.example <- function\n### this function does nothing in particular and does it very well\n(\n ##title<<Simple function arguments\n first,         ##<< the first argument with a multi-line description\n ## which I really have to put here rather than explaining in the details.\n second=        ##<< the second argument with a list default value\n ## and descriptions of each of the elements\n ##describe<<\n list(this=\"that\", ##<< whichness\n      the=\"other\", ##<< of the\n      rhubarb=\"stew\", ##<< why\n      foo=\"bar\"),\n ##end<<\n third ##<< an argument that does nothing\n )\n{\n  ##description<<why should I add to description?\n  ##details<<\n  ## if second is TRUE then first is returned\n  if ( second ){\n    ##alias<<Long silly alias\n    res <- first\n  } else {\n    ##details<<\n    ## if second is not TRUE then a list is returned\n    ##describe<<The contents of the list are:\n    res <- list(x=7, ##<< x coordinate\n                z= ##<< z describes everything else\n                ##describe<<\n                list(colour=\"green\", ##<< colour of line\n                     width=2),     ##<< width of line\n                ##end<<\n                ## and this line should get into documentation for z\n                y=10)##<< y coordinate\n  }\n  ##note<< a note\n  ##references<< a reference\n  ##seealso<< \\code{\\link{Silly-class}}\n  ##keyword<<documentation utilities\n  invisible(res)\n### invisible something not unrelated to first\n}",
    format="",
    description = "this function does nothing in particular and does it very well\nwhy should I add to description?",
    value = "invisible something not unrelated to \\code{first}",
    title = "Simple function arguments",
    `item{first}` = "the \\code{first} argument with a multi-line description\nwhich I really have to put here rather than explaining in the details.",
    `item{second}` = "the \\code{second} argument with a list default value\nand descriptions of each of the elements\\describe{\n\\item{this}{whichness}\n\\item{the}{of the}\n\\item{rhubarb}{why}\n}",
    `item{third}` = "an argument that does nothing",
    details = "if \\code{second} is TRUE then \\code{first} is returned\n\nif \\code{second} is not TRUE then a list is returned\n\nThe contents of the list are:\\describe{\n\\item{x}{x coordinate}\n\\item{z}{z describes everything else\\describe{\n\\item{colour}{colour of line}\n\\item{width}{width of line}\n}\nand this line should get into documentation for z}\n\\item{y}{y coordinate}\n}",
    alias = "Long silly alias", note = "a note", references = "a reference",
    seealso = "\\code{\\link{Silly-class}}", keyword = "documentation}\n\\keyword{utilities"),
  `Silly-class` = list(
    title = "S4 classes can be documented as well",
    description = "The Silly class does nothing much either",
    details = "Put what you like in documentation details,\nbut ideally reference construction methods.",
    `item{forwards}` = "forward operation", `item{reverse}` = "how to go backward",
    `item{crashes}` = "how many crashes", `section{Objects from the Class}` = "Put what you like in documentation details,\nbut ideally reference construction methods.",
    seealso = "", alias = "Silly"))

spaced <- function
### desc
(arg1,
 arg2
 ){
  x <- arg1
  x*2
### some result

}
.result <- list(
  spaced = list(
    definition = "spaced <- function\n### desc\n(arg1,\n arg2\n ){\n  x <- arg1\n  x*2\n### some result\n\n}",
    format = "",
    title = "spaced",
    value="some result",
    description="desc",
    "item{arg1}"="arg1 ",
    "item{arg2}"="arg2 "
  )
)

CalculateSampleCovariance <- function(x, y, verbose = TRUE) {
  # Computes the sample covariance between two vectors.
  #
  # Args:
  #   x: One of two vectors whose sample covariance is to be calculated.
  #   y: The other vector. x and y must have the same length, greater than one,
  #      with no missing values.
  #   verbose: If TRUE, prints sample covariance; if not, not. Default is TRUE.
  #
  # Returns:
  #   The sample covariance between x and y.
  n <- length(x)
  # Error handling
  if (n <= 1 || n != length(y)) {
    stop("Arguments x and y have invalid lengths: ",
         length(x), " and ", length(y), ".")
  }
  if (TRUE %in% is.na(x) || TRUE %in% is.na(y)) {
    stop(" Arguments x and y must not have missing values.")
  }
  covariance <- var(x, y)
  if (verbose)
    cat("Covariance = ", round(covariance, 4), ".\n", sep = "")
  return(covariance)
}

str_match_perl <- function(string,pattern){
  parsed <- regexpr(pattern,string,perl=TRUE)
  names <- attr(parsed,"capture.names")
  captured.text <- substr(string,parsed,parsed+attr(parsed,"match.length")-1)
  captured.text[captured.text==""] <- NA
  captured.groups <- do.call(rbind,lapply(seq_along(string),function(i){
    if(is.na(parsed[i]) || parsed[i]==-1)return(rep(NA,length(names)))
    st <- attr(parsed,"capture.start")[i,]
    substring(string[i],st,st+attr(parsed,"capture.length")[i,]-1)
  }))
  result <- cbind(captured.text,captured.groups)
  colnames(result) <- c("",names)
  result
}

str_match_all_perl <- function(string,pattern){
  parsed <- gregexpr(pattern,string,perl=TRUE)
  lapply(seq_along(parsed),function(i){
    r <- parsed[[i]]
    starts <- attr(r,"capture.start")
    if(r[1]==-1)return(matrix(nrow=0,ncol=1+ncol(starts)))
    names <- attr(r,"capture.names")
    lengths <- attr(r,"capture.length")
    full <- substring(string[i],r,r+attr(r,"match.length")-1)
    subs <- substring(string[i],starts,starts+lengths-1)
    m <- matrix(c(full,subs),ncol=length(names)+1)
    colnames(m) <- c("",names)
    m
  })
}


google <- function(src,...){
  # Extract docs from google header comments.
  #
  # Args:
  # src: lines of code of the function source.
  #
  # Returns:
  # An inner Documentation List.
  pre <- "\\W*#\\W+"
  lines.pat <- paste("(?:",pre,".*?\n)+",sep="")
  google.doc.pattern <-
    paste("(?<description>",lines.pat,")",
          pre,"Args:\\W*\n",
          "(?<args>",lines.pat,")",
          pre,"Returns:\\W*\n",
          "(?<value>",lines.pat,")",
          sep="")
  lines <- paste(src,collapse="\n")
  parsed <- str_match_perl(lines,google.doc.pattern)
  if(is.na(parsed[1]))return(list())
  docs <- list(description=gsub(pre,"",parsed[,"description"]),
               value=gsub(pre,"",parsed[,"value"]))
  arg.pat <-
    paste(pre,"(?<name>[a-z]+): ",
          "(?<content>.*?\n",
          "(?:",pre,"[^:]*?\n)*)",
          sep="")
  m <- str_match_all_perl(parsed[,"args"],arg.pat)[[1]]
  argsList <- as.list(gsub(paste("\n",pre,sep=""),"\n",m[,"content"]))
  names(argsList) <- sprintf("item{%s}",m[,"name"])
  lapply(c(docs,argsList),function(x)gsub("\n$","",x))
}

.parsers <- list(google=inlinedocs::forfun(google))

##src <- getSource(CalculateSampleCovariance)
## src <- getSource(google)
## src <- getSource(str_match_all_perl)
## google(src)

.dontcheck <- TRUE

.result <-
  list(google=list(description="Extract docs from google header comments.",
         `item{src}`="lines of code of the function source.",
         value="An inner Documentation List."),
       str_match_all_perl=list(),
       str_match_perl=list(),
       CalculateSampleCovariance=list(
         description="Computes the sample covariance between two vectors.",
         `item{x}`="One of two vectors whose sample covariance is to be calculated.",
         `item{y}`="The other vector. x and y must have the same length, greater than one,\nwith no missing values.",
         `item{verbose}`="If TRUE, prints sample covariance; if not, not. Default is TRUE.",
         value="The sample covariance between x and y."))

testFunc<-function(
### Generates a probability plot of probability limits from simulated data, including optional comparison with observed data
leg.txt=c("Obs","50% PL","90% PL") ##<< vector of legend text, default= \code{c("Obs","Sim. Median","Sim. 90% PL")}
){
return(leg.txt)  
}
.result <- 
 list(testFunc = list(definition = "testFunc<-function(\n### Generates a probability plot of probability limits from simulated data, including optional comparison with observed data\nleg.txt=c(\"Obs\",\"50% PL\",\"90% PL\") ##<< vector of legend text, default= \\code{c(\"Obs\",\"Sim. Median\",\"Sim. 90% PL\")}\n){\nreturn(leg.txt)  \n}",  
     description = "Generates a probability plot of probability limits from simulated data, including optional comparison with observed data",  
     `item{leg.txt}` = "vector of legend text, default= \\code{c(\"Obs\",\"Sim. Median\",\"Sim. 90% PL\")}",  
     format = "", title = "testFunc")) 
  

f <- function # title
### description
(x, ##<< arg x
 y
### arg y
 ){
  ##value<< a list with elements
  list(x=x, ##<< original x value
       y=y, ##<< original y value
       sum=x+y) ##<< their sum
  ##end<<
}

.result <- list(
  f = list(
    description = "description",
    `item{y}` = "arg \\code{y}",
    `item{x}` = "arg \\code{x}",
    value = "a list with elements\n\\item{x}{original \\code{x} value}\n\\item{y}{original \\code{y} value}\n\\item{sum}{their sum}",
    title = "title",
    format = ""))

silly.example <- structure(function
### this function does nothing in particular and does it very well
(
 ##title<<Simple function arguments
 first,         ##<< the first argument with a multi-line description
 ## which I really have to put here rather than explaining in the details.
 second=        ##<< the second argument with a list default value
 ## and descriptions of each of the elements
 ##describe<<
 list(this="that", ##<< whichness
      the="other", ##<< of the
      rhubarb="stew", ##<< why
      foo="bar"),
 ##end<<
 third ##<< an argument that does nothing
 )
{
  ##description<<why should I add to description?
  ##details<<
  ## if second is TRUE then first is returned
  if ( second ){
    ##alias<<Long silly alias
    res <- first
  } else {
    ##details<<
    ## if second is not TRUE then a list is returned
    ##describe<<The contents of the list are:
    res <- list(x=7, ##<< x coordinate
                z= ##<< z describes everything else
                ##describe<<
                list(colour="green", ##<< colour of line
                     width=2),     ##<< width of line
                ##end<<
                ## and this line should get into documentation for z
                y=10)##<< y coordinate
  }
  ##note<< a note
  ##references<< a reference
  ##seealso<< \code{\link{SillyTest-class}}
  ##keyword<<documentation utilities
  invisible(res)
### invisible something not unrelated to first
}, ex=function(){

  silly.example(1, TRUE)

})

setClass("SillyTest", # S4 classes can be documented as well
### The Silly class does nothing much either
         ##details<< Put what you like in documentation details,
         ## but ideally reference construction methods.
         representation(forwards="function", ##<< forward operation
                        reverse="function", ##<< how to go backward
                        crashes="integer") ##<< how many crashes
         ) ##<< this comment is ignored as it is outside setClass expression

## creates "show" generic function. Documentation of this not yet supported.
##setMethod("show","Silly",function(object){cat("crashed ",object@crashes," times\n")})

"vectorElements<-" <- function(
		### adds or replaces value in vec
		vec			##<< a named vector
		,value		##<< a named vector of same mode as vec
){
}

.result <- list(
  `vectorElements<-` = list(
    description = "adds or replaces \\code{value} in \\code{vec}",
    `item{vec}` = "a named vector",
    `item{value}` = "a named vector of same mode as \\code{vec}",
    format = "",
    title = "vectorElements<-"))

fermat.test <- function#Test an integer for primality with Fermat's little theorem.
### Fermat's little theorem states that if \eqn{n} is a prime number
### and \eqn{a} is any positive integer less than \eqn{n}, then
### \eqn{a} raised to the \eqn{n}th power is congruent to \eqn{a\
### modulo\ n}{a modulo n}.
##references<< \url{http://en.wikipedia.org/wiki/Fermat's_little_theorem}
(n ##<< the integer to test for primality.
 ){
  a <- floor(runif(1,min=1,max=n))
  ##note<< \code{fermat.test} doesn't work for integers above
  ##approximately 15 because modulus loses precision.
  a^n %% n == a
### Whether the integer passes the Fermat test for a randomized
### \eqn{0<a<n}
}
is.pseudoprime <- structure(function
### A number is pseudo-prime if it is probably prime, the basis of
### which is the probabalistic Fermat test; if it passes two such
### tests, the chances are better than 3 out of 4 that \eqn{n} is
### prime.
##references<< Abelson, Hal; Jerry Sussman, and Julie
##Sussman. Structure and Interpretation of Computer
##Programs. Cambridge: MIT Press, 1984.
(n, ##<< the integer to test for pseudoprimality.
 times ##<< the number of Fermat tests to perform
){
  if(times==0)TRUE
  ##seealso<< \code{\link{fermat.test}}
  else if(fermat.test(n)) is.pseudoprime(n,times-1)
  else FALSE
### Whether the number is pseudoprime.
},ex=function(){
  is.pseudoprime(13,4)
})

.result <- 
 list(fermat.test = list(format="",definition = "fermat.test <- function#Test an integer for primality with Fermat's little theorem.\n### Fermat's little theorem states that if \\eqn{n} is a prime number\n### and \\eqn{a} is any positive integer less than \\eqn{n}, then\n### \\eqn{a} raised to the \\eqn{n}th power is congruent to \\eqn{a\\\n### modulo\\ n}{a modulo n}.\n##references<< \\url{http://en.wikipedia.org/wiki/Fermat's_little_theorem}\n(n ##<< the integer to test for primality.\n ){\n  a <- floor(runif(1,min=1,max=n))\n  ##note<< \\code{fermat.test} doesn't work for integers above\n  ##approximately 15 because modulus loses precision.\n  a^n %% n == a\n### Whether the integer passes the Fermat test for a randomized\n### \\eqn{0<a<n}\n}",  
     title = "Test an integer for primality with Fermat's little theorem.",  
     description = "Fermat's little theorem states that if \\eqn{n} is a prime number\nand \\eqn{a} is any positive integer less than \\eqn{n}, then\n\\eqn{a} raised to the \\eqn{n}th power is congruent to \\eqn{a\\\nmodulo\\ n}{a modulo n}.",  
     value = "Whether the integer passes the Fermat test for a randomized\n\\eqn{0<a<n}",  
     references = "\\url{http://en.wikipedia.org/wiki/Fermat's_little_theorem}",  
     `item{n}` = "the integer to test for primality.", note = "\\code{fermat.test} doesn't work for integers above\napproximately 15 because modulus loses precision."),  
     is.pseudoprime = list(definition = "is.pseudoprime <- structure(function\n### A number is pseudo-prime if it is probably prime, the basis of\n### which is the probabalistic Fermat test; if it passes two such\n### tests, the chances are better than 3 out of 4 that \\eqn{n} is\n### prime.\n##references<< Abelson, Hal; Jerry Sussman, and Julie\n##Sussman. Structure and Interpretation of Computer\n##Programs. Cambridge: MIT Press, 1984.\n(n, ##<< the integer to test for pseudoprimality.\n times ##<< the number of Fermat tests to perform\n){\n  if(times==0)TRUE\n  ##seealso<< \\code{\\link{fermat.test}}\n  else if(fermat.test(n)) is.pseudoprime(n,times-1)\n  else FALSE\n### Whether the number is pseudoprime.\n},ex=function(){\n  is.pseudoprime(13,4)\n})",
         description = "A number is pseudo-prime if it is probably prime, the basis of\nwhich is the probabalistic Fermat test; if it passes two such\ntests, the chances are better than 3 out of 4 that \\eqn{n} is\nprime.",
       title="is pseudoprime",
         references = "Abelson, Hal; Jerry Sussman, and Julie\nSussman. Structure and Interpretation of Computer\nPrograms. Cambridge: MIT Press, 1984.",  
         `item{n}` = "the integer to test for pseudoprimality.",  
         `item{times}` = "the number of Fermat tests to perform",  
         seealso = "\\code{\\link{fermat.test}}", examples = "\nis.pseudoprime(13,4)\n",  
         value = "Whether the number is pseudoprime.",format="")) 

### A multi-line comment before a data item goes into the description
### section of its Rd file. The items of this list are all norms,
### which are functions that take a vector of N elements and return a
### non-negative real number.
norms <-
  structure(list(l0=function(x)sum(x!=0),
                 l1=function(x)sum(abs(x)),
                 l2=function(x)sqrt(sum(x^2)),
                 linfty=function(x)max(abs(x))),
            ex=function(){
              m <- replicate(2,rnorm(10))
              cbind(m,sapply(norms,function(norm)apply(m,1,norm)))
            })
.result <- 
 list(norms = list(definition = "norms <-\n  structure(list(l0=function(x)sum(x!=0),\n                 l1=function(x)sum(abs(x)),\n                 l2=function(x)sqrt(sum(x^2)),\n                 linfty=function(x)max(abs(x))),\n            ex=function(){\n              m <- replicate(2,rnorm(10))\n              cbind(m,sapply(norms,function(norm)apply(m,1,norm)))\n            })",  
     description = "A multi-line comment before a data item goes into the description\nsection of its Rd file. The items of this list are all norms,\nwhich are functions that take a vector of N elements and return a\nnon-negative real number.",  
     format = "", title = "norms", examples = "\nm <- replicate(2,rnorm(10))\ncbind(m,sapply(norms,function(norm)apply(m,1,norm)))\n")) 

### what is 90% of pi?
almost.pi <- 90/100 * pi

## percents should be escaped neither in inlinedocs, nor in
## Documentation Lists, but will be escaped when written to Rd files.
.result <- list(almost.pi=list(description="what is 90% of pi?",
                definition="almost.pi <- 90/100 * pi",
                format="",
                title="almost pi"))

read.fasta <- function
### Read sequences in FASTA format into a named character vector
(infile
### Name of the sequence file
 ){
  infile
}
##debug(read.fasta)

### Letters in the DNA alphabet, used to auto-detect sequence type
dna.letters <- c("*","A","T","G","C")
### DNA identity substitution matrix.
dna.identity <- matrix(0,nrow=length(dna.letters),ncol=length(dna.letters),
                       dimnames=list(dna.letters,dna.letters))
diag(dna.identity) <- 1
dna.identity['*','*'] <- 0
seqs.to.mat <- function
### Calculate pairwise differences between sequences using a
### substitution matrix.
(seq.vec,
### DNA or protein sequences.
 subs.mat=NULL){
### Substitution matrix with dimnames that match the letters used in
### the sequence data, or a character vector that specifies a common
### substitution matrix (as defined in the Biostrings package). NULL
### specifies that we will guess a suitable substitution matrix to
### match your input sequences (DNA=>identity, protein=>BLOSUM62).
  if(is.null(names(seq.vec)))names(seq.vec) <- seq.vec
  chars <- sapply(seq.vec,nchar)
  seqsum <- table(chars)
  chars
### The matrix of distances between each input sequence, with dimnames
### corresponding to either the sequences, or the sequence names (if
### they exist)
}
##debug(seqs.to.mat)

make.logo.ps <- function
### Create a logo using weblogo, then read it in using grImport
(helices,
### Sequences to plot in the logo
 psbase
### Base filename for the logo postscript and xml files, should be the
### full path name except for the trailing .ps
 ){
  psfile <- paste(psbase,'ps',sep='.')
  helices
### Grid picture grob as read using readPicture
}
##debug(make.logo.ps)

sublogo.dendrogram <- function
### Main function for drawing sublogo dendrograms.
(M,
### difference matrix as constructed by seqs.to.mat (although in
### principle any object with a valid as.dist method could be used)
 main='',
### plot title
 subtit=NULL,
### plot subtitle
 base=tempfile(),
### base file name for temporary logo files
 cutline=150,
### Distance for cutting the tree. Draw a sublogo for each
### leaf. Normally you will plot once, then inspect the dendrogram to
### determine which is a good value for cutline, then plot again using
### your chosen cutline.
 dend.width=30,
### Percent of the plot to be occupied by the dendrogram. The logos
### will be displayed with equal widths on either side.
 cex=1
### character expansion factor for the dendrogram
 ){
  hc <- hclust(as.dist(M),method="average")
  hc
### The dendrogram from the call to hclust
}
##debug(sublogo.dendrogram)

sublogo <- function
### Draw a sublogo dendrogram for a sequence motif.
(seqs,
### Character vector of DNA or protein sequences (optionally named
### with sequence labels).
 mat=NULL,
### Substitution matrix passed to seqs.to.mat.
 ...
### Other arguments to pass to sublogo.dendrogram (see that help page
### for a full description).
 ){
  sublogo.dendrogram(seqs.to.mat(seqs,mat),...)
}

.result <- list(
  dna.identity = list(
    description = "DNA identity substitution matrix.", format = "",
    title = "dna identity"),
  dna.letters = list(
    description = "Letters in the DNA alphabet, used to auto-detect sequence type",
    format = "", title = "dna letters"),
  make.logo.ps = list(
    description = "Create a logo using weblogo, then read it in using grImport",
    `item{helices}` = "Sequences to plot in the logo", `item{psbase}` = "Base filename for the logo postscript and xml files, should be the\nfull path name except for the trailing .ps",
    value = "Grid picture grob as read using readPicture", format = "",
    title = "make logo ps"),
  read.fasta = list(
    description = "Read sequences in FASTA format into a named character vector",
    `item{infile}` = "Name of the sequence file", format = "",
    title = "read fasta"),
  seqs.to.mat = list(
    description = "Calculate pairwise differences between sequences using a\nsubstitution matrix.",
    `item{seq.vec}` = "DNA or protein sequences.", `item{subs.mat}` = "Substitution matrix with dimnames that match the letters used in\nthe sequence data, or a character vector that specifies a common\nsubstitution matrix (as defined in the Biostrings package). NULL\nspecifies that we will guess a suitable substitution matrix to\nmatch your input sequences (DNA=>identity, protein=>BLOSUM62).",
    value = "The matrix of distances between each input sequence, with dimnames\ncorresponding to either the sequences, or the sequence names (if\nthey exist)",
    format = "", title = "seqs to mat"),
  sublogo = list(
    description = "Draw a sublogo dendrogram for a sequence motif.",
    `item{seqs}` = "Character vector of DNA or protein sequences (optionally named\nwith sequence labels).",
    `item{mat}` = "Substitution matrix passed to \\code{\\link{seqs.to.mat}}.",
    `item{\\dots}` = "Other arguments to pass to \\code{\\link{sublogo.dendrogram}} (see that help page\nfor a full description).",
    format = "", title = "sublogo"),
  sublogo.dendrogram = list(
    description = "Main function for drawing \\code{\\link{sublogo}} dendrograms.",
    `item{M}` = "difference matrix as constructed by \\code{\\link{seqs.to.mat}} (although in\nprinciple any object with a valid as.dist method could be used)",
    `item{main}` = "plot title", `item{subtit}` = "plot subtitle",
    `item{base}` = "\\code{base} file name for temporary logo files",
    `item{cutline}` = "Distance for cutting the tree. Draw a \\code{\\link{sublogo}} for each\nleaf. Normally you will plot once, then inspect the dendrogram to\ndetermine which is a good value for \\code{cutline}, then plot again using\nyour chosen \\code{cutline}.",
    `item{dend.width}` = "Percent of the plot to be occupied by the dendrogram. The logos\nwill be displayed with equal widths on either side.",
    `item{cex}` = "character expansion factor for the dendrogram",
    value = "The dendrogram from the call to hclust", format = "",
    title = "sublogo dendrogram"))
